module.exports = ({ authriteClient, config }) =>
  async (routePath, fetchConfig) => {
    // Make an authenticated request to the specified route
    const response = await authriteClient.request(
      `${config.dojoURL}/${routePath}`,
      fetchConfig
    )
    // Parse the results and return a JSON object
    const responseObject = JSON.parse(
      Buffer.from(response.body).toString('utf8')
    )

    // Error handling
    if (
      typeof responseObject === 'object' &&
      responseObject.status === 'error'
    ) {
      const e = new Error(responseObject.description)
      e.code = responseObject.code
      e.statusCode = response.status
      Object
        .keys(responseObject)
        .filter(x => x !== 'status' && x !== 'description')
        .forEach(x => { e[x] = responseObject[x] })
      throw e
    }
    return responseObject
  }
